/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.KelompokUserDao;
import com.portofolio.dto.KelompokUserDto;
import com.portofolio.entity.KelompokUser;
import com.portofolio.entity.vo.KelompokUserId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class KelompokUserService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private KelompokUserDao kelompokUserDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(KelompokUserDto kelompokUserDto) {
		result.clear();
		KelompokUserId id = new KelompokUserId();
		Integer kdKelompokUser =getIdTerahir(KelompokUser.class.getSimpleName());
		id.setKdKelompokUser(kdKelompokUser);
		id.setKdProfile(getKdProfile());
		KelompokUser kelompokUser = CommonUtil.findOne(kelompokUserDao, id);
		if (CommonUtil.isNullOrEmpty(kelompokUser)) {
			kelompokUser = new KelompokUser();
			BeanUtils.copyProperties(kelompokUserDto, kelompokUser);
			kelompokUser.setNoRec(generateUuid32());
			kelompokUser.setVersion(1);
			kelompokUser.setId(id);
			kelompokUser = kelompokUserDao.save(kelompokUser);
			result.put("kelompokUser", kelompokUser);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("kelompokUser.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(KelompokUserDto kelompokUserDto, Integer kdKelompokUser, Integer version) {
		result.clear();
		KelompokUserId id = new KelompokUserId();
		id.setKdKelompokUser(kdKelompokUser);
		id.setKdProfile(getKdProfile());
		KelompokUser kelompokUser = CommonUtil.findOne(kelompokUserDao, id);
		if (CommonUtil.isNotNullOrEmpty(kelompokUser)) {
			if (version < kelompokUser.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(kelompokUserDto, kelompokUser);
			kelompokUser.setVersion(version);
			kelompokUser = kelompokUserDao.save(kelompokUser);
			result.put("kelompokUser", kelompokUser);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaKelompokUser,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaKelompokUser)) {
			pageRes = kelompokUserDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = kelompokUserDao.findAllList(getKdProfile(), namaKelompokUser, statusEnabled, pageReq);
		}
		result.put("kelompokUser", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdKelompokUser(Integer kdKelompokUser) {
		result.clear();
		result.put("kelompokUser", kelompokUserDao.findByKdKelompokUser(getKdProfile(), kdKelompokUser, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdKelompokUser, Integer version) {
		result.clear();
		KelompokUserId id = new KelompokUserId();
		id.setKdKelompokUser(kdKelompokUser);
		id.setKdProfile(getKdProfile());
		KelompokUser kelompokUser = CommonUtil.findOne(kelompokUserDao, id);
		if (CommonUtil.isNotNullOrEmpty(kelompokUser)) {
			if (version < kelompokUser.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			kelompokUser.setStatusEnabled(false);
			kelompokUser.setVersion(version);
			kelompokUser = kelompokUserDao.save(kelompokUser);
			result.put("kelompokUser", kelompokUser);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
